package com.sun.org.apache.bcel.internal.generic;

import com.sun.org.apache.bcel.internal.classfile.ConstantUtf8;
import com.sun.org.apache.bcel.internal.classfile.ConstantPool;
import com.sun.org.apache.bcel.internal.classfile.ConstantCP;
import com.sun.org.apache.bcel.internal.classfile.ConstantNameAndType;

public abstract class NameSignatureInstruction extends CPInstruction
{
    public NameSignatureInstruction() {
    }
    
    public NameSignatureInstruction(short opcode, int index) {
        super(opcode, index);
    }
    
    public ConstantNameAndType getNameAndType(ConstantPoolGen cpg) {
        ConstantPool cp = cpg.getConstantPool();
        ConstantCP cmr = (ConstantCP)cp.getConstant(super.getIndex());
        return (ConstantNameAndType)cp.getConstant(cmr.getNameAndTypeIndex());
    }
    
    public String getSignature(ConstantPoolGen cpg) {
        ConstantPool cp = cpg.getConstantPool();
        ConstantNameAndType cnat = this.getNameAndType(cpg);
        return ((ConstantUtf8)cp.getConstant(cnat.getSignatureIndex())).getBytes();
    }
    
    public String getName(ConstantPoolGen cpg) {
        ConstantPool cp = cpg.getConstantPool();
        ConstantNameAndType cnat = this.getNameAndType(cpg);
        return ((ConstantUtf8)cp.getConstant(cnat.getNameIndex())).getBytes();
    }
}
